// ============================================================================
#ifndef OSTAPDATAFRAME_H 
#define OSTAPDATAFRAME_H 1
// ============================================================================
// STD&STL
// ============================================================================
#include <string>
// ============================================================================
// ROOTm ROOT::ROOT
// ============================================================================
#include "RVersion.h" // ROOT 
// ============================================================================
#if ROOT_VERSION(6,14,0)<=ROOT_VERSION_CODE 
// ============================================================================
#include "ROOT/RDataFrame.hxx" // ROOT 
// ============================================================================
#else 
// ============================================================================
#include "ROOT/TDataFrame.hxx" // ROOT 
// ============================================================================
#endif 
// ============================================================================
// Ostap
// ============================================================================
#include "Ostap/DataFrame.h"
// ============================================================================
// Local
// ============================================================================
#include "local_utils.h"
// ============================================================================
namespace
{
  // ==========================================================================
  /** Any of from these symbols implies that the variable name 
   *  is not a primitive one
   */
  const std::string s_SYMBOLS = " */+-%|&^()[]!$?<>=";
  /// Is a variable name "primitive" (no operations) ?
  inline bool primitive ( const std::string& name )
  { return std::string::npos == name.find_first_of ( s_SYMBOLS ) ; }
  // ==========================================================================
  /// is this selection/weight a trivial one? 
  inline bool trivial ( const std::string& selection ) 
  {
    return 
      ""     == selection || 
      "1"    == selection || 
      "1."   == selection || 
      "1.0"  == selection || 
      "true" == selection || 
      "True" == selection || 
      std::string::npos == selection.find_first_not_of (' ') ;
  }
  // ==========================================================================
} //                                             The end of anonymous namespace
// ============================================================================
//                                                                      The END 
// ============================================================================
#endif // OSTAPDATAFRAME_H
// ============================================================================
